* Channel information for extended channel definition block (PE)
* PWITTE May 25th 1995
*
        section util

        xdef    chinfo
        xdef    xtop_chinfo     ;may need xref.l to address trap directly
*
chinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Channel information subroutine using xtop
*
* No checking is performed on the offset as to whether it is even, or whether
* it is actually within the channel table!
*
* input :
*       d1.l = offset required
*       d2.w = type flag -1 = byte, 0 = word, 1 = long
*       d3.w = timeout
*       a0   = channel id
*
* return:
*       d1.b, .w or .l = info
*       a1   -> channel header
*       errors: any channel errors with condition codes set
*       all other registeres preserved
*
        move.l  a2,-(a7)
        lea.l   xtop_chinfo,a2  ;routine address
        moveq   #9,d0           ;iow.xtop
        trap    #3
        move.l  (a7)+,a2
        tst.l   d0
        rts
*
xtop_chinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Channel information
* No checking is performed on the offset as to whether it is even or
* actually within the channel table!
*
* input :
*       d1.l = offset required
*       d2.w = type flag -1 = byte, 0 = word, 1 = long
*       a0   = channel id
*
* return:
*       d1.b, .w or .l = info
*       a1   -> channel header
*       errors: any channel errors, condition codes NOT set
*       all other registeres preserved
*
        moveq   #0,d0           ;no errors from this point!
        lea.l   -$30(a0),a1     ;pointer to the (extended) channel header
        tst.w   d2
        bmi.s   ci_byte
        beq.s   ci_word
        move.l  0(a1,d1.l),d1   ;get required parameter
        rts
ci_byte
        move.b  0(a1,d1.l),d1
        rts
ci_word
        move.w  0(a1,d1.l),d1
        rts
*
        end
