* ut_fhead - load file header into sbasic buffer
*
* pjwitte 2oi9+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef ut_fhead

        include dev8_keys_qdos_io
        include dev8_keys_hdr
        include dev8_keys_sbasic

*
ut_fhead
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* input:  a0 = channel ID of open file
* output: a1 -> fhead (a6 rel)
* errors: file eror
* all other regs preserved
*
regs    reg d1-d3
        movem.l regs,-(sp)

        moveq #iof.rhdr,d0      header read

        moveq #hdr.len,d2       whole length
        move.l sb_buffb(a6),a1  into buffer

        trap #do.relio          relative a6
        moveq #forever,d3       set infinite timeout
        trap #do.io
        move.l sb_buffb(a6),a1  reset buffer pointer

        movem.l (sp)+,regs
        tst.l d0

        rts

*
        end
