* General SuperBASIC utilities
*
        section code

        xdef    resbf

*
resbf
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Sub-routine to reserve (additional) room in SuperBASIC buffer
* Note: Some versions of BASIC will never return this space again (even after
*       a NEW. Does not include SMSQ, Minerva.
*       Some versions of BASIC may not adjust the relevant pointers after this
*       call. Does not include the above or, apparently, 1G10 emulator
*
* input  :
*          d1.l = number of bytes required
* return : cc     ???
*          errors: none, but will return to address pointed to by bv_sssav
*                 if an error occurred
*          various area pointers and a6/a7 may change during this call
*          d1 preserved, no other registers affected
*
        movem.l d1-d3/a1-a2,-(a7)
        move.w  $11a,a2
        jsr     $1c(a2)                 this offset is not documented
        movem.l (a7)+,d1-d3/a1-a2       (but appears to be generally supported)
        rts
*
        end
