* General SuperBASIC routine to get parameter type
*
        section code

        xdef    partype
*
partype
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Parses the parameter details and returns Scalarity, Type, & Seperator
* input :
*       a3  -> parameter (a6 rel) Must exist!
*
* return:    cc set
*       d2.w = seperator following parameter in lsb, bit #15 set if hashed
*       d5.w = type: -2 = substring  -1 = string, 0 = float, 1 = integer
*       d6.w = kind of variable: 0=unset, 1=expr, 2=scalar, 3=array
*       errors: bp = null
*       all other registeres preserved
*
        moveq   #0,d0           ;assume not null
        move.w  0(a6,a3.l),d2   ;get type info
        move.w  d2,d5
        andi.w  #$0f0f,d5       ;strip out seperator info
        bne.s   pt_0
        moveq   #-15,d0         ;null parameter
pt_0
        sub.w   d5,d2           ;d2.b = seperator
        bclr    #7,d2           ;clear hash bit if present
        beq.s   pt_1
        bset    #15,d2          ;move hash bit to msb
pt_1
        move.w  d5,d6           ;d6 = kind
        lsr.w   #8,d6           ;clear msb of kind and move into lsb
        ext.w   d5              ;clear msb of type and move into lsb
        subq.w  #2,d5           ;convert to our internal type
        tst.l   d0
        rts
*
        end
