* Reserve room on stack and float return
* PWITTE 1995
* V0.03C - Combined
* V0.04  - New info on qa.resri/bv.chrix - this should work for all systems
* V0.05, pjw, 2020 Oct 14, Wee tweak saving 2b

        section code

        xdef l2frtr,l2frtrd6,l2freta1,lin2fltd6,retflt

        include dev8_keys_sbasic
        include dev8_keys_qlv

*
l2frtr
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* input :
*       d1.l = long integer value to convert
*       stack must be in a tidy ("empty") state prior to this call
*
* return: cc = set
*       errors: returns directly to BASIC with d0 = 0 (or OM)
*
        move.l  d1,d6           save value
*
l2frtrd6
        moveq   #6,d1           reserve 6 bytes on stack for float

*       move.l  sb_arthp(a6),a1 V0.04 - this was a mistake in documentation

        move.w  qa.resri,a2
        jsr     (a2)

        subq.l #6,sb_arthp(a6)

*
l2freta1
        movea.l sb_arthp(a6),a1

*
lin2fltd6
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert a long integer in d6 to a floating point number on a stack
*
* There must be 6b free space on stack with a1 and stack pointer pointing to it
*
* input :
*        d6.l = long integer to convert
*        a1  -> six free bytes on stack
*
* return :   cc set
*        a1  -> floating point number on stack
*        d6   = ???
*        errors: always 0
*
        move.l  d6,d0           if 0 skip all this
        beq.s   l2f_ret

        move.w  #$81F,d0        exponent bias
*
lin_loop
        add.l   d6,d6           normalise: loop until
        dbvs    d0,lin_loop       sign changes (fiddling exp all the while)

        roxr.l  #1,d6           back one restoring last bit shifted out

l2f_ret

        move.w  d0,0(a6,a1.l)   that's exponent done
        move.l  d6,2(a6,a1.l)   that's the mantissa done

retflt
        moveq   #ar.float,d4    return code = float
        moveq   #0,d0           never fails
        rts

*
        end
