* sputp_a1
*
* pjwitte 2oi8+
* All code is my own work except as and where stated
*
* V0.02, pjw, June 4th 2019, check for valid parameter
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef sputp_a1

        include dev8_keys_qlv
        include dev8_keys_sbasic

*
sputp_a1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Return a string on the ri.stack through parameter list. Only act if
* the parameter is of type str.  Any other parameter type is skipped, but
* not reported as error.
*
*       call                          return
* d1.w  return value         preserved
* a1    -> string            preserved
* a3    -> parameter         -> next parmater (if any)
* all other registeres preserved
*
* On a functional error: returns to previous caller with a3 undefined
* If parameter is not a str, then skip
*

regs    reg d1-d3/a0-a2

        move.b 1(a6,a3.l),d0    get par type
        andi.b #$0f,d0          strip
        subq.w #1,d0            string?
        beq.s doit              yes, ok

        moveq #0,d0              no, no error, but
        bra.s rts                 dont do it

doit
        movem.l regs,-(sp)

        move.l a1,sb_arthp(a6)
        move.w sb.putp,a2       bp.let
        jsr (a2)

        movem.l (sp)+,regs
        beq.s rts

        addq.l #4,a7            error back to previous

rts
        addq.l #nt.len,a3       next par
        rts

*
        end
