* ut_bf16to3x
*
* V0.01, pjwitte 2oi9+
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*

        section code

        xdef ut_bf16to3x

        xref tab_16to33

*
ut_bf16to3x
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert 8bit graphics data mode 16 to 16bit mode 3x
* Target buffer must be different and 2 x size of source buffer!
* No padding
*
* input:
* d1.l = input buffer len in bytes
* a1   = routine address: cv_16to32 or cv_16to33
* a2  -> input buffer
* a4  -> output buffer
*
* output:
* a2/a4        updated
* d0/d1/d3/a3  smashed
*
* Always "succeeds" - no error or CC
*

        lea.l tab_16to33,a3
        move.w #$00ff,d0        byte mask

        bra.s lend16

loop16
        move.b (a2)+,d3

        jsr (a1)

        move.w d3,(a4)+

lend16
        subq.l #1,d1
        bpl.s loop16

        rts

*
        end
