* ut_bf3xto3x
*
* V0.01, pjwitte 2oi9+
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*

        section code

        xdef ut_bf3xto3x


*
ut_bf3xto3x
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert 16bit graphics data mode 32 or 33 to 16bit mode 33 or 32
* Source buffer and target buffer may refer to the same location
* With padding
*
* input:
* d1.l = input buffer len in bytes
* d2.w = x-size in pixels
* a1   = routine address, ie 33to32 or 32to33
* a2  -> input buffer
* a4  -> output buffer
*
* output:
* a2/a4          updated
* d0/d1/d3d4/a3  smashed
*
* other regs preserved or unaffected
*
* Always "succeeds" - no error or CC
*

        move.w d2,d4
        bra.s lend

loop
        move.w (a2)+,d3

        jsr (a1)

        move.w (a3,d3.w),(a4)+

        subq.w #1,d4
        bne.s lend

pad
        clr.w (a4)+             pad this line
        move.w d2,d4            start again

lend
        subq.l #2,d1
        bpl.s loop

        rts

*
        end
