* cv_16to32t
*
* V0.01, pjwitte 2oi9+
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*
* This routine involves a second table to tab_16to33. Since PC-based
* platforms are likely to be faster than "QL" hardware, an alternative
* cv_16to32 has been implemented, which does the conversion in two stages:
* cv_16to33 -> cv_33to32 and thus only involves a single table for both
* cv_16to33 and cv_16to32.
*
* There is no ut_cv16to32t! Only ut_cv16to32.

        section code

        xdef cv_16to32t

*
cv_16to32t
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of 8bit mode 16 graphics data to mode 32 (QPC/QXL)
*
* input:
* d3.b = grbgrbgx       - colour to convert
* d4.w = #$00ff         - byte mask
* a3  -> tab_16to32
*
* output
* d3.w = mode 32 colour
*
* d4/a3   preserved
*
* All other regs unchanged
*
* Always "succeeds" - no error or CC
*

        and.w d4,d3             strip off sign
        add.w d3,d3             make offset
        move.w (a3,d3.w),d3

        rts

*
        end
