* ut_cv16to33
*
* V0.01, pjwitte 2oi9+
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*

        section code

        xdef cv_16to33

*
cv_16to33
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of 8bit mode 16 graphics data to mode 33 (Qx0/Q68)
*
* input:
* d0.w = #$00ff         - byte mask
* d3.b = grbgrbgx       - colour to convert
* a3  -> tab_16to33
*
* output
* d3.w = mode 33 colour
*
* d0/a3   preserved
*
* All other regs unchanged
*
* Always "succeeds" - no error or CC
*

        and.w d0,d3             strip off sign
        add.w d3,d3             make offset
        move.w (a3,d3.w),d3

        rts

*
        end
