* cv_32to33
*
* V0.01, pjwitte 2oi9+
*
* V0.02, Replaced my conversion code with MK's more efficient code
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*


        section code

        xdef ut_cv32to33
        xdef cv_32to33


*
ut_cv32to33
*
cv_32to33
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of mode 33 graphics data to mode 32
*
* input:
* d3.w = ggwBBBbb RRRrrGGG      - colour to convert
*
* output:
* d3.w = GGGggRRR rrBBBbbw      - where w = g6
*
* d4/d5  smashed
*
* Always "succeeds" - no error or CC
*

        rol.w    #3,d3                      ; bbbbbrrr rrgggggw
        move.w   d3,d4
        move.w   d3,d5
        andi.w   #%0000011111000001,d3      ; -----rrr rr-----w
        andi.w   #%0000000000111110,d4      ; -------- --ggggg-
        andi.w   #%1111100000000000,d5      ; bbbbb--- --------
        ror.w    #6,d4                      ; ggggg--- --------
        rol.w    #6,d5                      ; -------- --bbbbb-
        or.w     d4,d3                      ; gggggrrr rr-----w
        or.w     d5,d3                      ; gggggrrr rrbbbbbw

        rts

*
        end
