* cv_33to32
*
* V0.01, pjwitte 2oi9+
*
* V0.02, Replaced my conversion code with MK's more efficient code
*
* Compatible with QDOS, Minerva and SMSQ/E (but GD2 gfx data only)
*

        section code

        xdef ut_cv33to32
        xdef cv_33to32

*
ut_cv33to32
*
cv_33to32
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert one item of mode 33 graphics data to mode 32
*
* input:
* d3.w = GGGggRRR rrBBBbbw      - colour to convert
*
* output:
* d3.w = ggwBBBbb RRRrrGGG      - where w = g6
*
* d4/d5  smashed
*
* Always "succeeds" - no error or CC
*
        ror.w    #3,d3                      ; bbwggggg rrrrrbbb
        move.w   d3,d4
        move.w   d4,d5
        andi.w   #%0001111100000000,d3      ; 000ggggg 00000000
        andi.w   #%0010000011111000,d4      ; 00w00000 rrrrr000
        andi.w   #%1100000000000111,d5      ; bb000000 00000bbb
        ror.w    #6,d5                      ; 000bbbbb 00000000
        rol.w    #6,d3                      ; gg000000 00000ggg
        or.w     d4,d3
        or.w     d5,d3

        rts

*
        end
