* StrCmp: Alphabetical string comparison routines using user-defined tables  *
*            String Comparison subroutine using tabled byte order            *
*                                                                            *
*  PWITTE February 10th 1995                                                *
*
* V0.02 November 12th 2006 - simplified for release
*                                                                            *
        section code

        xdef    strcmpA6
*
strcmpA6
*
* Low-level access * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* Compares two strings pointed to by a0 and a1 and sets the condition codes
* according to whether a0 = a1 (Z=1, C=0)
*                      a0 > a1 (Z=0, C=1)
*                      a0 < a1 (Z=0, C=0)
* Entry conditions                              Exit conditions
*                                               Condition codes set (as above)
* a0  -> len 0+str 0                            a0 =  ?
* a1  -> len 1+str 1                            a1 =  ?
* a4  -> Character table                        a4 =  unchanged
* d0.w = 0                                      d0 - d4 =  ?
*
* addresses relative to a6
*

        move.w  0(a6,a0.l),d3   get len 0
        move.w  0(a6,a1.l),d4   get len 1
        beq.s   sc_lencmp       done, except to compare lengths!

        move.w  d3,d2           try len 0 for size
        beq.s   sc_lencmp       done! compare lengths

        cmp.w   d4,d3           get shorter length
        bcc.s   sc_lend         len 0 was shorter start loop
        move.w  d4,d2           len 1 was shorter
        bra.s   sc_lend         start
sc_loop
        move.b  2(a6,a1.l),d0   get char1 first
        move.b  0(a4,d0.w),d1   get its position from table
        addq.l  #1,a1

        move.b  2(a6,a0.l),d0   get char0
        addq.l  #1,a0
        cmp.b   0(a4,d0.w),d1   char0 - char1

sc_lend
        dbne    d2,sc_loop
        bne.s   sc_ret          inequality in string: return cc as set

sc_lencmp                       ; equal: test inequality in lengths
        cmp.w   d3,d4

sc_ret
        rts

        end
