* StrCmp: Alphabetical string comparison routines using case indifferent
* comparison. Without tables
*
*  PWITTE February 10th 1995, April 29th 1998
*
        section code

        xdef    strcmp
*
strcmp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Compares two strings pointed to by a0 and a1 and sets the condition codes
* according to whether a0 = a1 (Z=1, C=0)
*                      a0 > a1 (Z=0, C=1)
*                      a0 < a1 (Z=0, C=0)
* Routine can be speeded up if one or both strings are known to be in lower
* case: Remove one instance of lower and move the other in-line, or remove
* both, as the case may be
*
* Entry conditions                              Exit conditions
*                                               Condition codes set (as above)
* a0  -> qstr 0                                 a0 =  ?
* a1  -> qstr 1                                 a1 =  ?
* d0.w = 0                                      d0 - d4 =  ?
*

        move.w  (a0)+,d3                ;get len 0
        move.w  (a1)+,d4                ;get len 1
        beq.s   sc_lencmp               ;done, except to compare lengths!
        move.w  d3,d2                   ;try len 0 for size
        beq.s   sc_lencmp               ;done! compare lengths
        cmp.w   d4,d3                   ;get shorter length
        bcc.s   sc_lend                 ;len 0 was shorter start loop
        move.w  d4,d2                   ;len 1 was shorter
        bra.s   sc_lend                 ;start
sc_loop
        move.b  (a1)+,d0                ;get char1
        bsr.s   lower
        move.b  d0,d1
        move.b  (a0)+,d0                ;get char0
        bsr.s   lower
        cmp.b   d0,d1                   ;char0 - char1
sc_lend
        dbne    d2,sc_loop
        bne.s   sc_ret                  ;inequality in string: return cc as set
sc_lencmp                               ;equal: test inequality in lengths
        cmp.w   d3,d4
sc_ret
        rts
*
lower
        cmpi.b  #'A',d0
        bcs.s   notran
        cmpi.b  #'Z',d0
        bcc.s   mklo
        cmpi.b  #'',d0                 ;chr(160)
        bcs.s   notran
        cmpi.b  #'',d0                 ;chr(171)
        bcc.s   mkhi
notran
        rts
mklo
        addi.b  #' ',d0
        rts
mkhi
        subi.b  #' ',d0
        rts
*
        end
