* StrCmp: Alphabetical string comparison routines using case indifferent
* comparison. With tables
*
*  PWITTE February 10th 1995, April 29th 1998, January & April 2oo2
*
* V0.02 - simplified: eq or neq only
* V0.03 - allows zero string length comparisons (afterall)

        section code

        xdef    strequTab

strequTab
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Compares two strings pointed to by a0 and a1 and sets the condition codes
* accordingly: eq => same, ne => different
*
* Entry conditions                              Exit conditions
*                                               Condition codes set (as above)
* d0.w/d1.w = 0                                 d0,d1,d3,d4 =  ?
* a0  -> qstr 0                                 a0 =  ?
* a1  -> qstr 1                                 a3 =  ?
* a4  -> tra tab                                a4 preserved
*
        move.b 0(a6,a0.l),d4            get len0
        move.w 0(a6,a1.l),d3            get len1
        cmp.w d3,d4                     same lengths?
        bne.s sc_ret                     no, not found

        lea.l 2(a1),a3                  -> str1
        addq.l #1,a0                    -> str0

        bra.s sc_lend                   take into account zero len

sc_loop
        move.b 0(a6,a0.l),d0            get char0
        move.b 0(a4,d0.w),d0            lowercase

        move.b 0(a6,a3.l),d1            get char1
        move.b 0(a4,d1.w),d1

        addq.l #1,a0                    next char
        addq.l #1,a3

        cmp.b d0,d1

sc_lend
        dbne d3,sc_loop

sc_ret
        rts

*
        end
