* cmpelm
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with SMSQ/E, and with QDOS and Minerva when compiled only!
*


        section code

        xdef cmpelm
        xref ut_cstrcmp,ut_nstrcmp

        include dev8_keys_qlv

*
cmpelm
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* Compare elements by type:
*
*  d0.l =               result -1 (X < Y), 0 (X = Y), 1 (X > Y)
*  d1                   smashed
*  d5.l = type          saved    0.comp type.b | 0.variable type.b
*  a0  -> X             smashed
*  a1  -> Y             smashed
*  a2                   smashed
*  a6                   saved    base register (used only by ut.cstr)
*
*

*
tab
        dc.w sbyte_cmp-tab          $00
        dc.w ubyte_cmp-tab          $02
        dc.w sword_cmp-tab          $04
        dc.w uword_cmp-tab          $06
        dc.w slong_cmp-tab          $08
        dc.w ulong_cmp-tab          $0A
        dc.w fltpt_cmp-tab          $0C
        dc.w qstrg_cmp-tab          $0E
        dc.w cstrg_cmp-tab          $10
        dc.w nstrg_cmp-tab          $12

*
sbyte_cmp
        cmp.b (a1)+,(a0)+
        bra.s signed

*
sword_cmp
        cmp.w (a1)+,(a0)+
        bra.s signed

*
slong_cmp
        cmp.l (a1)+,(a0)+

signed
        beq.s eq
        blt.s mi
        bgt.s pl

*
ubyte_cmp
        cmp.b (a1)+,(a0)+
        bra.s unsigned

*
uword_cmp
        cmp.w (a1)+,(a0)+
        bra.s unsigned

*
ulong_cmp
        cmp.l (a1)+,(a0)+

unsigned
        beq.s eq
        bcs.s mi
        bhi.s pl

*
qstrg_cmp
        move.l d5,d0
        swap d0                        Qdos comparison type
        suba.l a6,a1
        suba.l a6,a0
        move.w ut.cstr,a2              jsr ut.cstr*3+qlv.ofs+2
        jmp (a2)

*
cstrg_cmp
        move.l d5,d0
        swap d0                        Simple comparison type
        bra ut_cstrcmp

nstrg_cmp
        move.l d5,d0
        swap d0                        Simple comparison type
        bra ut_nstrcmp

*
fltpt_cmp                               ; cmp.f f1,f0; where
        move.l 2(a0),d0
        cmp.l 2(a1),d0
        bvc.s flt_ss                    sign same

        tst.l d0                        signs different so
        bra.s flt_done                   return comparison

flt_ss
        tst.l d0                        signs positive?
        bmi.s flt_neg

        cmp.w (a1)+,(a0)+               how do exps compare?
        bne.s flt_done                   different magnitude

        cmp.l (a1),d0                    same magnitude ( 2(a1) )

flt_done
        bmi.s mi
        beq.s eq

pl
        moveq #1,d0
        rts

eq
        moveq #0,d0
        rts

mi
        moveq #-1,d0
        rts

flt_neg
        cmp.w (a0)+,(a1)+
        bne.s flt_done

        cmp.l (a1),d0
        bra.s flt_done

*
        end
