* ut_cstrcmp
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef ut_cstrcmp

        xref ut_lcchr

        include dev8_keys_err



*
ut_cstrcmp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Note: Case = 0: This is a character-by-character comparison. It doesnt
*       conform to the lexical priorities used by Qdos/SMSQ
*       Case = 1: Case agnostic. May not work for "foreign" character sets
*
* input:  d0.b  = cmptype (0 or <> 0)
*         a0 -> C-string0
*         a1 -> C-string1
*
* return: d0.l = -1, 0, 1 or err.ov
*         cc set accordingly
*         All regs preserved
*
strreg  reg d1/d2/a0/a1

        movem.l strreg,-(sp)

        move.w #32764,d2        max Q-string length (excl terminating 0)

        bsr.s case

return
        movem.l (sp)+,strreg
        rts


case
        tst.b d0
        bne.s case1

case0

*
loop
        move.b (a0)+,d0
        beq.s test

        move.b (a1)+,d1
        beq.s pl                str0 > str1

        cmp.b d0,d1
        dbne d2,loop

endtest
        blt.s pl
        bgt.s mi
        bra.s err_ov

test                            ; come here if end str0
        move.b (a1)+,d1
        beq.s eq

mi
        moveq #-1,d0
        rts

pl
        moveq #1,d0
        rts

eq
        moveq #0,d0
        rts

err_ov
        moveq #err.ovfl,d0
        rts

*
case1
        move.b (a0)+,d0
        beq.s test

        move.b (a1)+,d1
        beq.s pl                str0 > str 1

        bsr ut_lcchr
        exg d0,d1

        bsr ut_lcchr
        exg d0,d1

        cmp.b d0,d1
        dbne d2,case1

        bra.s endtest

*
        end
