* SB numeric comparison routines
*
         section  ncomp

         xdef     int_cmp
         xdef     flt_cmp
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Compare two number and return one of three possible results
*
* input  :a0 => base of first number (a6 rel)
*         a1 => base of second number (a6 rel)
* output :d0.l = result: n1 < n2 = -1, n1 = n2 = 0, n1 > n2 = 1
*         d1 smashed (flt cmp only)
*         a0/a1 preserved
*         no other registeres affected
*


int_cmp                                 ;signed integers
         move.w   0(a6,a0.l),d0
         cmp.w    0(a6,a1.l),d0
         bra.s    cmp_test
*
flt_cmp                                 ;cmp.f f1,f0
         move.l   2(a6,a0.l),d0
         move.l   2(a6,a1.l),d1
         eor.l    d0,d1
         bpl.s    flt_ss                ;sign same
         cmp.l    2(a6,a1.l),d0         ;signs different so
         bra.s    cmp_test              ; return comparison
flt_ss
         tst.l    d0                    ;signs positive?
         bmi.s    flt_neg               ; no
         move.w   0(a6,a0.l),d1         ; yes so
         cmp.w    0(a6,a1.l),d1         ; how do exps compare?
         bne.s    cmp_test              ;  different magnitude
         cmp.l    2(a6,a1.l),d0         ;  same magnitude; cmp mants again
cmp_test
         bmi.s    cmp_sm
         beq.s    cmp_eq
cmp_gt
         moveq    #1,d0
         rts
cmp_eq
         moveq    #0,d0
         rts
cmp_sm
         moveq    #-1,d0
         rts
flt_neg
         move.w   0(a6,a1.l),d1
         cmp.w    0(a6,a0.l),d1
         bne.s    cmp_test
         cmp.l    2(a6,a1.l),d0
         bra.s    cmp_test
*
         end
