* ut_nstrcmp
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef ut_nstrcmp

        xref ut_lcchr

        include dev8_keys_err



*
ut_nstrcmp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Note: Case = 0: This is a character-by-character comparison. It doesnt
*       conform to the lexical priorities used by Qdos/SMSQ
*       Case = 1: Case agnostic. May not work for "foreign" character sets
*
* input:  d0.b  = cmptype (0 or <> 0)
*         a0 -> N-string0
*         a1 -> N-string1
*
* return: d0.l = -1, 0, 1
*         cc set accordingly
*         All regs preserved
*
strreg  reg d1-d4/a0/a1

        movem.l strreg,-(sp)

        moveq #0,d2
        bsr.s case

return
        movem.l (sp)+,strreg
        rts

case
        move.b  (a0)+,d3        get len 0
        move.b  (a1)+,d4        get len 1
        beq.s   sc_lencmp       done, except to compare lengths!

        move.b  d3,d2           try len 0 for size
        beq.s   sc_lencmp       done! compare lengths

        cmp.b   d4,d3           get shorter length
        bcc.s   begin           len 0 was shorter start loop

        move.b  d4,d2           len 1 was shorter

begin
        subq.w #1,d2

        tst.b d0
        bne.s sc1_loop          case 1

sc_loop
        cmp.b   (a0)+,(a1)+

sc_lend
        dbne    d2,sc_loop

sc_end
        bne.s   sc_ret

sc_lencmp                       ; equal: test inequality in lengths
        cmp.b   d3,d4
        beq.s   eq

*
sc_ret
        blt.s pl

mi
        moveq #-1,d0
        rts

pl
        moveq #1,d0
        rts

eq
        moveq #0,d0
        rts

*
sc1_loop

        move.b (a1)+,d0
        bsr ut_lcchr

        move.b d0,d1
        move.b (a0)+,d0
        bsr ut_lcchr

        cmp.b d0,d1

sc1_lend
        dbne d2,sc1_loop

        bne.s sc_ret
        bra.s sc_end

*
        end
