* Conversion routines
*
* pjwitte 2oo4
* V0.01
*

        section code

        xdef cv_in2st

        include dev8_keys_qlv

*
cv_in2st
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Convert integer to string with/without leading zeros. Number of digits
*
* input:  d1.w = value to convert
*         d4.b = zero flag: 0 => no leading zeros, +ve => leading zeros
*         d5.w = number of digits
*         a6   = base register
*
* return: string in buffer
*         a1  -> string
*         d1-d3/d5/a2/a3 = ???
*         cc ???
*         no errors

        move.l a0,-(a7)         save channel id

        move.w d1,d3            copy of value

        sub.l a1,a1             point to value
        move.w d1,0(a6,a1.l)     but put it there first

        lea.l 2(a1),a0          a0 -> buffer, past len

        move.w cv.iwdec,a2      convert int to str
        jsr (a2)

        subq.l #2,a1            a1 -> len

        tst.b d4
        beq.s noz

        adda.l a6,a1            stop mucking about with base registers now
        move.w d5,(a1)          len = no. digits

        tst.w d3                value negative?
        bpl.s pos

        addq.l #1,a1            got the minus already
        subq.w #1,d5
        subq.w #1,d1

pos
        lea.l 2(a1,d5.w),a0     a0 -> past end of resultant string
        lea.l 2(a1,d1.w),a1     a1 -> past end of number string
        sub.w d1,d5             d5 = number of leading zeros

        bra.s mend

noz
        move.w d1,0(a6,a1.l)    put len in place
        bra.s rts

mve
        move.b -(a1),-(a0)      right align
mend
        dbra d1,mve

        bra.s zend
zero
        move.b #'0',-(a0)       fill remaining spaces (if any) with zero
zend
        dbra d5,zero

        suba.l a1,a1            a -> start of buffer (rel a6)

rts
        move.l (a7)+,a0
        rts

*
        end
