* ut_fload - load a file into memory
*
* pjwitte 2oi9+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef ut_fload,ut_fclose

        include dev8_keys_qdos_io
        include dev8_keys_qdos_ioa



*
ut_fload
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* input:  d2 = length of file
*         d3 = 0 => dont close, +ve => close
*         a0 = channel ID of open file
*         a1 = memory address
* output: a0   preseved if not closed
*         a1   updated (or smashed, if closed)
* errors: channel not open
* all other regs preserved
*

        move.l d3,-(sp)
        moveq #forever,d3       set infinite timeout
        moveq #iof.load,d0
        trap #do.io
        move.l (sp)+,d3
        bne.s ut_fclose

        tst.l d0
        rts

*
ut_fclose
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* input:  a0 = channel ID of open file
* output: a0/a1 smashed

* errors: inherited

* all other regs preserved
*

        move.l d0,-(sp)
        moveq #ioa.clos,d0
        trap #do.ioa
        move.l (sp)+,d0
        rts

*
        end
