* StrCmp: Alphabetical string comparison routines using case indifferent
* comparison. Without tables
*
*  PWITTE February 10th 1995, April 29th 1998, January 23rd 2002
*
* V0.02  - simplified: eq or neq only
* V0.03  - allows zero string length comparisons (afterall)
* V0.03n - specially modified for str0 to be a nametable string!

        section code

        xdef strequnt

strequnt
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Compares two strings pointed to by a0 and a1 and sets the condition codes
* accordingly: eq => same, ne => different
*
* Entry conditions                      Exit conditions
*                                       Condition codes set (as above)
*                                       d0,d1,d3 =  ?
* d4.w (msb) must be 0!                 d4.b = ?
* a0  -> ntstr 0                        a0 =  ?
* a1  -> qstr 1                         a3 =  ?
*
        move.b 0(a6,a0.l),d4            get len0 (nametable string length!)
        move.w 0(a6,a1.l),d3            get len1 (qstr)
        cmp.w  d3,d4                    same lengths?
        bne.s sc_ret                     no, not found

        lea.l 2(a1),a3                  -> str1
        addq.l #1,a0                    -> str0

        bra.s sc_lend                   take into account zero len

sc_loop
        move.b 0(a6,a0.l),d0            get char0
        addq.l #1,a0
        bsr.s upper
        move.b d0,d1

        move.b 0(a6,a3.l),d0            get char1
        addq.l #1,a3
        bsr.s upper

        cmp.b d0,d1
sc_lend
        dbne d3,sc_loop

sc_ret
        rts

upper
        cmpi.b #'a',d0
        blo.s notrans                   bcs.s
        cmpi.b #'z',d0
        bhi.s foreign
        subi.b #' ',d0
        rts

foreign
        cmpi.b #139,d0
        bhi.s notrans
        cmpi.b #128,d0
        blo.s notrans
        addi.b #' ',d0

notrans
        rts

*

        end
