* Jump to Thing Utility through Hotkey System II
*  1989 Tony Tebby / Jochen Merz
* Adapted by PWITTE November 18th 1995
*
        section code

        xdef    thg_getvec

*
thg_getvec
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Find Thing utility vectors of HOTKEY System II (HK V2.03+ only)
*
* entry : d0.w = thh_exec ($0C) or thh_entry ($08)
*
* return: cc = set
*       a4 -> Thing utility vector (entr or exec)
*       errors: NIMP - no Thing list, THING Thing not found
*       all other registers preserved
*
        movem.l d1-d3/a0,-(sp)  protect from sms.info
        move.l  d0,d3
        moveq   #0,d0           sms.info
        trap    #1
        move.l  $b8(a0),d1      sys_thgl, this is the Thing list
        beq.s   thg_nf          list was empty!
thg_loop
        movea.l d1,a0           next link
        move.l  (a0),d1         get next list entry
        beq.s   thg_found       end of list? Should be THING
        bra.s   thg_loop
thg_nf
        moveq   #-19,d0         THING does not exist
        bra.s   thg_ret
thg_found
        move.l  $10(a0),a0      get start of thing
        cmp.l   #-1,4(a0)       is it our special THING?
        bne.s   thg_nf           nope
        move.l  0(a0,d3.w),a4   a4 -> desired vector
        moveq   #0,d0
thg_ret
        movem.l (sp)+,d1-d3/a0
        rts
*
        end
